import { SlMenuItem } from "@shoelace-style/shoelace";

interface ShoelaceEventMap {
    "sl-after-hide": CustomEvent<{}>;
    "sl-after-show": CustomEvent<{}>;
    "sl-blur": CustomEvent<{}>;
    "sl-cancel": CustomEvent<{}>;
    "sl-change": CustomEvent<{}>;
    "sl-clear": CustomEvent<{}>;
    "sl-error": CustomEvent<{}>;
    "sl-finish": CustomEvent<{}>;
    "sl-focus": CustomEvent<{}>;
    "sl-hide": CustomEvent<{}>;
    "sl-input": CustomEvent<{}>;
    "sl-load": CustomEvent<{}>;
    "sl-mutation": CustomEvent<{ mutationList: MutationRecord[] }>;
    "sl-request-close": CustomEvent<{}>;
    "sl-remove": CustomEvent<{}>;
    "sl-reposition": CustomEvent<{}>;
    "sl-resize": CustomEvent<{ entries: ResizeObserverEntry[] }>;
    "sl-select": CustomEvent<{ item: SlMenuItem }>;
    "sl-show": CustomEvent<{}>;
    "sl-start": CustomEvent<{}>;
    "sl-tab-hide": CustomEvent<{}>;
    "sl-tab-show": CustomEvent<{}>;
}

declare global {
    interface HTMLElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLAnchorElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLAnchorElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLAreaElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLAreaElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLBodyElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLBodyElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLButtonElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLButtonElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLDListElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLDListElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLDataElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLDataElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLDataListElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLDataListElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLDetailsElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLDetailsElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLDialogElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLDialogElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLDivElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLDivElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLFieldSetElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLFieldSetElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLFormElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLFormElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLHeadElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLHeadElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLHeadingElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLHeadingElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLHtmlElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLHtmlElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLLIElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLLIElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLLabelElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLLabelElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLLegendElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLLegendElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLLinkElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLLinkElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLMapElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLMapElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLMenuElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLMenuElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLOListElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLOListElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLParagraphElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLParagraphElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLPreElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLPreElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLQuoteElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLQuoteElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLSpanElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLSpanElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLTableCellElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLTableCellElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLTableElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLTableElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLTableRowElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLTableRowElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLTableSectionElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLTableSectionElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }

    interface HTMLUListElement {
        addEventListener<EventName extends keyof ShoelaceEventMap>(
            type: EventName,
            listener: (
                this: HTMLUListElement,
                event: ShoelaceEventMap[EventName],
            ) => void,
            options?: boolean | AddEventListenerOptions,
        ): void;
    }
}

export {};
